//suchen und hinfahren

#include <Servo.h>

Servo schaufel;
int pinServo = A5;

int photoVL = A4;
int photoVR = A3;
int photoHL = A2;
int photoHR = A1;
int photoSchaufel = A0;
 
int umgebungslichtS;
int umgebungslichtVR;
int umgebungslichtVL;

int anfangswertVL;
int anfangswertVR;
int anfangswertHL;
int anfangswertHR;
int anfangswertS;

int stepOben = 6;
int dirOben = 7;
int stepRechts = 3;
int dirRechts = 2;
int stepLinks = 5;
int dirLinks = 4; 

int LEDS = 12;
int LEDVL = 11;
int LEDVR = 10;

int infrarot = A6;

int abstand;

int aufTisch(int pinVorneL, int pinVorneR, int wertVorneR, int wertVorneL){
  Serial.println("Funktion aufTisch");
  Serial.println("Vorne Rechts");
  Serial.println(analogRead(photoVR));
  Serial.println("Vorne Links");
  Serial.println(analogRead(photoVL));
  if ((analogRead(pinVorneR) - umgebungslichtVR) < (wertVorneR - 30) || (analogRead(pinVorneR) - umgebungslichtVR) > (wertVorneR + 30)){
    digitalWrite(dirLinks, HIGH);
    for (int i=1; i < 200; i++){
      digitalWrite(stepLinks,HIGH);
      digitalWrite(stepRechts,HIGH);
      delay(25);
      digitalWrite(stepLinks, LOW);
      digitalWrite(stepRechts, LOW);
      delay(25);
    }
    digitalWrite(dirLinks, LOW);
    return 0;
  }
  else if ((analogRead (pinVorneL) - umgebungslichtVL) < (wertVorneL - 30) || (analogRead(pinVorneL) - umgebungslichtVL) > (wertVorneL + 30)){
    digitalWrite(dirRechts, LOW);
    for (int i=1; i < 200; i++){
      digitalWrite(stepLinks,HIGH);
      digitalWrite(stepRechts,HIGH);
      delay(25);
      digitalWrite(stepLinks, LOW);
      digitalWrite(stepRechts, LOW);
      delay(25);
    }
    digitalWrite(dirRechts, HIGH);
    return 0;
  }
  return 1;
}


int gegenstandFinden(char pin){
  digitalWrite(dirOben, HIGH);    //HIGH = rechts ; LOW = links
  int defaultwert = analogRead (pin);  //woanders deklarieren? im setup?
  abstand = defaultwert;
  for (int i=1;i<=200;i++){
    digitalWrite(stepOben,HIGH);
    delay(100);
    digitalWrite(stepOben, LOW);
    delay(100);
    if(analogRead (pin) > (defaultwert + 50) || analogRead(pin) < (defaultwert - 50))
    {    //abweichend vom defaultwert mit gewisser Toleranzgrenze
      abstand = analogRead(pin);
      Serial.print("abstand");
      Serial.print("\t");
      Serial.println(i);
      //infrarot wieder zum Ausgangspunkt zurück
      if (digitalRead(dirOben) == HIGH){
        digitalWrite(dirOben, LOW);
      }
      else{
        digitalWrite(dirOben, HIGH);
      }
      for (int back=1; back <= i; back++){
      digitalWrite(stepOben,HIGH);
      delay(25);
      digitalWrite(stepOben, LOW);
      delay(25);
    }
      return i;
    }
  }
  
  if (abstand == defaultwert){
    //fahre 20 Schritte geradeaus; die genannten Pins kommen aus dem Code "hinfahren"
    for (int i=0; i<20; i++){
      digitalWrite(stepLinks,HIGH);
      digitalWrite(stepRechts,HIGH);
      delay(10);
      digitalWrite(stepLinks, LOW);
      digitalWrite(stepRechts, LOW);
      if(aufTisch(photoVR, photoVL, anfangswertVR, anfangswertVL) == 0) {
        digitalWrite(dirRechts,HIGH);
        digitalWrite(dirLinks,LOW);
        return 0;
      }
     
      }
    return 0; 
  }
}
  
int hinfahren (int schritte){
  schritte*=4 ;
  digitalWrite(dirRechts, LOW);
  
  for (int i=1; i <= schritte; i++){
    digitalWrite(stepLinks,HIGH);
    digitalWrite(stepRechts,HIGH);
    delay(25);
    digitalWrite(stepLinks, LOW);
    digitalWrite(stepRechts, LOW);
    delay(25);
    int puffer = aufTisch( photoVR, photoVL, anfangswertVR, anfangswertVL);
    digitalWrite(dirRechts,LOW);
    digitalWrite(dirLinks,LOW);
  }
  digitalWrite(dirRechts, HIGH);
  anfangswertS = analogRead(photoSchaufel);
  while(analogRead(photoSchaufel) <= (anfangswertS + 50) && analogRead(photoSchaufel) >= (anfangswertS - 50))
  {
    digitalWrite(stepLinks,HIGH);
    digitalWrite(stepRechts,HIGH);
    delay(10);
    digitalWrite(stepLinks, LOW);
    digitalWrite(stepRechts, LOW);
    delay(10);
    Serial.println("Funktion hinfahren");
    Serial.println("Vorne Rechts");
    Serial.println(analogRead(photoVR));
    Serial.println("Vorne Links");
    Serial.println(analogRead(photoVL));
    if( aufTisch(photoVR, photoVL,anfangswertVR, anfangswertVL) == 0) {
      digitalWrite(dirRechts,HIGH);
      digitalWrite(dirLinks,LOW);
      return 0;
    }
  }
  int j = 0;
  while( j < 30){
    Serial.println("for-scheife");
    digitalWrite(stepLinks,HIGH);
    digitalWrite(stepRechts,HIGH);
    delay(10);
    digitalWrite(stepLinks, LOW);
    digitalWrite(stepRechts, LOW);
    delay(10);
    j = j + 1;
  }
  aufsammeln();
  return 1;
}


void aufsammeln(){
  int pos;
  for(pos = 90; pos <= 250; pos += 1){ 
    schaufel.write(pos);              
    delay(5);                       
  }
  for(pos = 250; pos>=90; pos-=1)     
  {                                
    schaufel.write(pos);              
    delay(5);                       
  }

}




void setup(){
  
  //serielle Schnittstelle, Einstellungen für die Pins der Stepper, den Pin des Infrarotsensors
  
  Serial.begin(115200);
  pinMode(stepOben, OUTPUT);
  pinMode(dirOben, OUTPUT);
  pinMode(infrarot, INPUT);
  pinMode(stepRechts, OUTPUT);
  pinMode(dirRechts, OUTPUT);
  pinMode(stepLinks, OUTPUT);
  pinMode(dirLinks, OUTPUT);
  pinMode(LEDS, OUTPUT);
  pinMode(LEDVL, OUTPUT);
  pinMode(LEDVR, OUTPUT);
  
  digitalWrite(LEDS,LOW);
  digitalWrite(LEDVL,LOW);  
  digitalWrite(LEDVR,LOW);
  
   
  umgebungslichtS = analogRead(photoSchaufel);
  umgebungslichtVR = analogRead(photoVR);
  umgebungslichtVL = analogRead(photoVL);
  
  //beide unteren Räder müssen in dieselbe Richtung fahren
  digitalWrite(dirRechts,HIGH);
  digitalWrite(dirLinks,LOW);
  
  digitalWrite(LEDS,HIGH);
  digitalWrite(LEDVL,HIGH);
  digitalWrite(LEDVR, HIGH);
  
  schaufel.attach(pinServo, 800, 2100);
  
  anfangswertVL = (analogRead(photoVL) - umgebungslichtVL);
  anfangswertVR = (analogRead(photoVR) - umgebungslichtVR);
  anfangswertHL = analogRead(photoHL);
  anfangswertHR = analogRead(photoHR);
  anfangswertS = (analogRead(photoSchaufel) - umgebungslichtS);
  Serial.println("setup");
  Serial.println("Vorne Rechts");
  Serial.println(analogRead(photoVR));
  Serial.println("Vorne Links");
  Serial.println(analogRead(photoVL));  
    
  
  /*int pos ;
  for(pos = 180; pos >= 90; pos -= 1){ 
    schaufel.write(pos);              
    delay(15);                      
  }*/
  
  
}

void loop(){
  int winkel = gegenstandFinden (infrarot); 
  if(winkel!= 0){
    hinfahren (winkel);
  }
}

